diff --git a/logview/logrtns.h b/logview/logrtns.h
index 891869a..20106f5 100644
--- a/logview/logrtns.h
+++ b/logview/logrtns.h
@@ -21,72 +21,19 @@
 #ifndef __LOGRTNS_H__
 #define __LOGRTNS_H__
 
-#include <time.h>
 #include <libgnomevfs/gnome-vfs.h>
+#include "logview-log.h"
 
-typedef struct
-{
-    GDate *date;
-    long first_line, last_line; /* First and last line for this day in the log */
-    gboolean expand;
-    GtkTreePath *path;
-} Day;
+G_BEGIN_DECLS
 
-typedef struct
-{
-    time_t file_time;
-    GnomeVFSFileSize file_size;
-} LogStats;
+/* call by log_repaint */
+Day * log_find_day (Log *self, const GDate* date);
 
-typedef struct TreePathRange
-{
-  GtkTreePath *first;
-  GtkTreePath *last;
-}TreePathRange;
+/* log utilities base on the plugin interfaces */
+void log_extract_filepath (Log* self, gchar** dirname, gchar** filename);
+gboolean log_has_been_modified (Log* self);
+gboolean log_run (Log* self);
 
-typedef struct _log Log;
-struct _log
-{
-	char *name;
-	char *display_name;
-	LogStats *stats;
-
-    GSList *days;
-    gchar **lines;
-	gint selected_line_first;
-	gint selected_line_last;
-	gint total_lines; /* no of lines in the file */
-    gint displayed_lines; /* no of lines displayed now */
-
-	/* Monitor info */
-	GnomeVFSFileSize mon_offset;
-	GnomeVFSMonitorHandle *mon_handle;
-    GnomeVFSHandle *mon_file_handle;
-	gboolean monitored;
-    gboolean needs_refresh;
-
-	gboolean first_time;
-    GtkTreeModel *model;
-    GtkTreeModelFilter *filter;
-    GList *bold_rows_list;
-	TreePathRange selected_range;
-    GtkTreePath *visible_first;
-
-	int versions;
-	int current_version;
-	/* older_logs[0] should not be used */
-	Log *older_logs[5];
-	Log *parent_log;
-	
-    gpointer window;
-};
-
-gboolean file_is_log (char *filename, gboolean show_error);
-Log *log_open (char *filename, gboolean show_error);
-gboolean log_read_new_lines (Log *log);
-gboolean log_unbold (gpointer data);
-void log_close (Log * log);
-gchar *log_extract_filename (Log *log);
-gchar *log_extract_dirname (Log *log);
+G_END_DECLS
 
 #endif /* __LOGRTNS_H__ */
diff --git a/logview/logview-debug.c b/logview/logview-debug.c
new file mode 100644
index 0000000..d3c602b
--- /dev/null
+++ b/logview/logview-debug.c
@@ -0,0 +1,74 @@
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <stdio.h>
+#include <glib.h>
+#include <glib/gstdio.h>
+#include "misc.h"
+#include "logview-debug.h"
+
+#define LOGVIEW_USER_PATH_SUFFIX LOGVIEW_HOME_SUFFIX "/gnome-system-log.log"
+static LogviewLevelFlags debug = LOGVIEW_INFO;
+static FILE *logf;
+
+void
+lv_debug (LogviewLevelFlags level,
+	  const gchar *file,
+	  gint line,
+	  const gchar *function)
+{
+        g_return_if_fail (file && function && line >= 0);
+	if (debug & level) {
+		g_fprintf (logf, "\"%s\" %s:%d\n", file, function, line);
+		fflush (stdout);
+	}
+}
+
+void
+lv_debug_message (LogviewLevelFlags level,
+		  const gchar *file,
+		  gint line,
+		  const gchar *function,
+		  const gchar *format, ...)
+{
+	if (debug & level) {
+		va_list ap;
+		g_return_if_fail (file && function && line >= 0);
+
+		if (debug & LOGVIEW_VERBOSE) {
+			g_fprintf (logf, "\"%s\" %s:%d ", file, function, line);
+			fflush (stdout);
+		}
+
+		va_start (ap, format);
+		g_vfprintf (logf, format, ap);
+		g_fprintf (logf, "\n");
+		va_end (ap);
+		fflush (stdout);
+	}
+}
+
+void
+logview_debug_init ()
+{
+	gchar *f = g_build_path (G_DIR_SEPARATOR_S, (gchar*)g_get_home_dir (),
+			     LOGVIEW_USER_PATH_SUFFIX, NULL);
+	logf = g_fopen (f, "wb");
+	g_free (f);
+
+	if (g_getenv ("LOGVIEW_DEBUG") != NULL)	{
+		debug |= LOGVIEW_ERR | LOGVIEW_VERBOSE;
+	}
+	if (g_getenv ("LOGVIEW_VERBOSE") != NULL) {
+		debug |= LOGVIEW_VERBOSE;
+	}
+}
+
+void
+logview_debug_destroy ()
+{
+	fclose (logf);
+	logf = NULL;
+}
+
diff --git a/logview/logview-debug.h b/logview/logview-debug.h
new file mode 100644
index 0000000..f02a1db
--- /dev/null
+++ b/logview/logview-debug.h
@@ -0,0 +1,87 @@
+#ifndef __LOGVIEW_DEBUG_H__
+#define __LOGVIEW_DEBUG_H__
+#include <glib.h>
+
+/**
+ * LogviewLevelFlags:
+ * @LOGVIEW_INFO: Normal information will be displayed in this level.
+ * @LOGVIEW_VERBOSE: Like %LOGVIEW_INFO, more information like file name,
+ * function name and line number will be displayed in this level.
+ * @LOGVIEW_ERR: Cover all above levels, displays verbose information
+ * for debugging usage.
+ * 
+ * Used to specify the level of the log of gnome-system-log.
+ **/
+typedef enum {
+	LOGVIEW_INFO		= 1 << 0,
+	LOGVIEW_VERBOSE		= 1 << 1,
+	LOGVIEW_ERR		= 1 << 2
+} LogviewLevelFlags;
+
+void logview_debug_init ();
+void logview_debug_destroy ();
+void lv_debug (LogviewLevelFlags level,
+	       const gchar *file,
+	       gint line,
+	       const gchar *function);
+void lv_debug_message (LogviewLevelFlags level,
+		       const gchar *file,
+		       gint line,
+		       const gchar *function,
+		       const gchar *format, ...);
+
+#ifdef ON_SUN_OS
+#define FUNC __func__
+#else
+#define FUNC G_STRFUNC
+#endif
+
+/**
+ * LV_MARK:
+ * 
+ * Dump out information in the %LOGVIEW_ERR level.
+ **/
+#define LV_MARK \
+	lv_debug (LOGVIEW_ERR, __FILE__, __LINE__, FUNC)
+
+/**
+ * LV_INFO:
+ * @FORMAT: a formatted string.
+ * @Varargs: 
+ * 
+ * Dump out information in the %LOGVIEW_VERBOSE and %LOGVIEW_INFO level.
+ **/
+#define LV_INFO(FORMAT, ...)  \
+	lv_debug_message (LOGVIEW_INFO, __FILE__, __LINE__, FUNC, "[II] " FORMAT, __VA_ARGS__)
+
+/**
+ * LV_INFO_WW:
+ * @FORMAT: a formatted string.
+ * @Varargs: 
+ * 
+ * Like LV_INFO(), dump out warnning information.
+ **/
+#define LV_INFO_WW(FORMAT, ...)  \
+	lv_debug_message (LOGVIEW_INFO, __FILE__, __LINE__, FUNC, "[WW] " FORMAT, __VA_ARGS__)
+
+/**
+ * LV_INFO_EE:
+ * @FORMAT: a formatted string.
+ * @Varargs: 
+ * 
+ * Like LV_INFO(), dump out error information.
+ **/
+#define LV_INFO_EE(FORMAT, ...)  \
+	lv_debug_message (LOGVIEW_INFO, __FILE__, __LINE__, FUNC, "[EE] " FORMAT, __VA_ARGS__)
+
+/**
+ * LV_ERR:
+ * @FORMAT: a formatted string.
+ * @Varargs: 
+ * 
+ * Dump out information in the %LOGVIEW_ERR level.
+ **/
+#define LV_ERR(FORMAT, ...)  \
+	lv_debug_message (LOGVIEW_ERR, __FILE__, __LINE__, FUNC, FORMAT, __VA_ARGS__)
+
+#endif
diff --git a/logview/logview-findbar.c b/logview/logview-findbar.c
index c70ff16..8c6477b 100644
--- a/logview/logview-findbar.c
+++ b/logview/logview-findbar.c
@@ -22,6 +22,7 @@
 #include <glib/gi18n.h>
 #include "logview.h"
 #include "logview-findbar.h"
+#include "log_repaint.h"
 
 struct LogviewFindBarPriv
 {
@@ -55,9 +56,15 @@ logview_findbar_clear (GtkWidget *widget, gpointer data)
 {
 	LogviewFindBar *findbar = LOGVIEW_FINDBAR (data);
 	LogviewWindow *logview = LOGVIEW_WINDOW (findbar->priv->logview);
+	GtkTreeModelFilter *filter;
 	Log *log = logview->curlog;
 
-	if (log==NULL || log->filter == NULL)
+	if (log==NULL)
+ 		return;
+	g_object_get (G_OBJECT (log),
+		      "filter", &filter,
+		      NULL);
+	if (filter == NULL)
  		return;
 
 	gtk_entry_set_text (GTK_ENTRY (findbar->priv->entry), "");
@@ -70,21 +77,28 @@ logview_findbar_entry_timeout (gpointer data)
 	LogviewFindBar *findbar = LOGVIEW_FINDBAR (data);
 	LogviewWindow *logview = LOGVIEW_WINDOW (findbar->priv->logview);
 	Log *log = logview->curlog;
+	GtkTreeModel *model;
+	GtkTreeModelFilter *filter;
 	GdkCursor *cursor;
 
+	g_object_get (G_OBJECT (log),
+		      "model", &model,
+		      "filter", &filter,
+		      NULL);
 	cursor = gdk_cursor_new (GDK_WATCH);
 	gdk_window_set_cursor (GTK_WIDGET (logview)->window, cursor);
 	gdk_cursor_unref (cursor);
 	gdk_display_flush (gtk_widget_get_display (GTK_WIDGET (logview)));
 	
-	if (log->filter == NULL) {
+	if (filter == NULL) {
 
-		log->filter = GTK_TREE_MODEL_FILTER (gtk_tree_model_filter_new (log->model, NULL));
-		gtk_tree_model_filter_set_visible_func (log->filter, iter_is_visible, findbar, NULL);
-		gtk_tree_view_set_model (GTK_TREE_VIEW (logview->view), GTK_TREE_MODEL (log->filter));
+		filter = GTK_TREE_MODEL_FILTER (gtk_tree_model_filter_new (model, NULL));
+		gtk_tree_model_filter_set_visible_func (filter, iter_is_visible, findbar, NULL);
+		gtk_tree_view_set_model (GTK_TREE_VIEW (logview->view), GTK_TREE_MODEL (filter));
+		g_object_set (G_OBJECT (log), "filter", filter, NULL);
 
 	} else {
-		gtk_tree_model_filter_refilter (log->filter);
+		gtk_tree_model_filter_refilter (filter);
 	}
 
 	gtk_tree_view_expand_all (GTK_TREE_VIEW (logview->view));
@@ -103,13 +117,19 @@ logview_findbar_entry_changed_cb (GtkEditable *editable,
 	LogviewFindBar *findbar = LOGVIEW_FINDBAR (data);
 	LogviewWindow *logview = LOGVIEW_WINDOW (findbar->priv->logview);
 	Log *log = logview->curlog;
+	GtkTreeModelFilter *filter;
 	gchar *search_string;    
 
 	search_string = g_strdup (gtk_entry_get_text (GTK_ENTRY (findbar->priv->entry)));
+	g_object_get (G_OBJECT (log),
+		      "filter", &filter,
+		      NULL);
 	
-	if (strlen (search_string) == 0 && log->filter != NULL) {
-		g_object_unref (log->filter);
-		log->filter = NULL;
+	if (strlen (search_string) == 0 && filter != NULL) {
+		g_object_unref (filter);
+		g_object_set (G_OBJECT (log),
+			      "filter", NULL,
+			      NULL);
 		logview_repaint (logview);
 		return;
 	}
@@ -143,7 +163,7 @@ logview_findbar_connect (LogviewFindBar *findbar, LogviewWindow *logview)
 static void 
 logview_findbar_init (LogviewFindBar *findbar)
 {
-	GtkWidget *label, *button;
+	GtkWidget *label;
 	
 	findbar->priv = g_new0 (LogviewFindBarPriv, 1);
 
diff --git a/logview/logview-iface-collector.c b/logview/logview-iface-collector.c
new file mode 100644
index 0000000..3d97d6f
--- /dev/null
+++ b/logview/logview-iface-collector.c
@@ -0,0 +1,99 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#include "logview-iface.h"
+#include "logview-iface-collector.h"
+#include "logview-debug.h"
+
+static void
+logview_iface_base_init (gpointer gclass)
+{
+	static gboolean initialized = FALSE;
+	if (!initialized) {
+		initialized = TRUE;
+	}
+}
+
+static void
+logview_iface_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LogviewIFaceCollector *self = (LogviewIFaceCollector *)g_class;
+	self->config_log = NULL;
+	self->config_log_from_path = NULL;
+	self->config_log = NULL;
+}
+
+GType
+logview_iface_collector_get_type (void)
+{
+	static GType type = 0;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (LogviewIFaceCollector),
+			logview_iface_base_init,   /* base_init */
+			NULL,   /* base_finalize */
+			logview_iface_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			0,
+			0,      /* n_preallocs */
+			NULL    /* instance_init */
+		};
+		type = g_type_register_static (G_TYPE_INTERFACE,
+					       g_intern_static_string ("LogviewIFaceCollectorType"),
+					       &info, 0);
+		g_type_interface_add_prerequisite (type, LOGVIEW_TYPE_IFACE);
+	}
+	return type;
+}
+
+/**
+ * logi_get_logs:
+ * @self: a #LogviewICollector instance.
+ * 
+ * Gnome System Log get logs by invoking this routine.
+ * 
+ * Returns: a single list, each element is a string represents a log name.
+ **/
+GSList*
+logi_get_logs (LogviewICollector *self)
+{
+	LV_MARK;
+	return LOGVIEW_GET_COLLECTOR_INTERFACE (self)->get_logs(self);
+}
+
+/**
+ * logi_config_log_from_path:
+ * @self: a #LogviewICollector instance.
+ * @log_name: log name which is obtained from logi_get_logs().
+ * 
+ * Gnome System Log tries to config a log instance by passing the log name to this routine.
+ *
+ * Returns: On successful completion, returns a #Log instance; else returns NULL.
+ **/
+Log* 
+logi_config_log_from_path (LogviewICollector *self, const gchar *log_name)
+{
+	LV_MARK;
+	return LOGVIEW_GET_COLLECTOR_INTERFACE (self)->config_log_from_path (self, log_name);
+}
+
+/**
+ * logi_config_log:
+ * @self: a #LogviewICollector instance.
+ * @log: a #Log instance.
+ * 
+ * Gnome System Log tries to config a log instance by passing the @log to this routine.
+ *
+ * Returns: On successful completion, returns TRUE; else returns FALSE.
+ **/
+gboolean
+logi_config_log (LogviewICollector *self, Log *log)
+{
+	LV_MARK;
+	return LOGVIEW_GET_COLLECTOR_INTERFACE (self)->config_log (self, log);
+}
+
diff --git a/logview/logview-iface-collector.h b/logview/logview-iface-collector.h
new file mode 100644
index 0000000..495301a
--- /dev/null
+++ b/logview/logview-iface-collector.h
@@ -0,0 +1,52 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifndef __LOGVIEW_IFACE_COLLECTOR_H__
+#define __LOGVIEW_IFACE_COLLECTOR_H__
+
+#include <glib-object.h>
+#include "logview-log.h"
+
+G_BEGIN_DECLS
+
+#define LOGVIEW_TYPE_IFACE_COLLECTOR \
+	(logview_iface_collector_get_type ())
+#define LOGVIEW_IFACE_COLLECTOR(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST((obj), LOGVIEW_TYPE_IFACE_COLLECTOR, \
+				     LogviewICollector))
+#define LOGVIEW_IS_IFACE_COLLECTOR(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE((obj), LOGVIEW_TYPE_IFACE_COLLECTOR))
+#define LOGVIEW_GET_COLLECTOR_INTERFACE(obj) \
+	(G_TYPE_INSTANCE_GET_INTERFACE((obj), LOGVIEW_TYPE_IFACE_COLLECTOR, \
+					LogviewIFaceCollector))
+
+typedef struct _LogviewICollector LogviewICollector; /* dummy object */
+typedef struct _LogviewIFaceCollector LogviewIFaceCollector;
+
+struct _LogviewIFaceCollector {
+	GTypeInterface parent;
+
+	/* Generate a new list of log names, need be freed */
+	GSList* (*get_logs) (LogviewICollector *self);
+
+	/* Create a log instance from path name, returns NULL if fails. */
+	Log* (*config_log_from_path) (LogviewICollector *self,
+				      const gchar *log_name);
+
+	/* configure a log instance */
+	gboolean (*config_log) (LogviewICollector *self, Log *log);
+};
+
+extern GType logview_iface_collector_get_type (void) G_GNUC_CONST;
+
+/* for logview application internal usage */
+extern GSList* logi_get_logs (LogviewICollector *self);
+extern Log* logi_config_log_from_path (LogviewICollector *self,
+				const gchar *log_name);
+extern gboolean logi_config_log (LogviewICollector *self, Log *log);
+
+G_END_DECLS
+
+#endif /* __LOGVIEW_IFACE_COLLECTOR_H__ */
diff --git a/logview/logview-iface-io.c b/logview/logview-iface-io.c
new file mode 100644
index 0000000..ddfd532
--- /dev/null
+++ b/logview/logview-iface-io.c
@@ -0,0 +1,212 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#include "logview-iface.h"
+#include "logview-iface-io.h"
+#include "logview-debug.h"
+
+static void
+logview_iface_base_init (gpointer gclass)
+{
+	static gboolean initialized = FALSE;
+	if (!initialized) {
+		initialized = TRUE;
+	}
+}
+
+static void
+logview_iface_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LogviewIFaceIO *self = (LogviewIFaceIO *)g_class;
+	self->can_monitor = NULL;
+	self->extract_filepath = NULL;
+	self->has_updated = NULL;
+	self->update = NULL;
+	self->read = NULL;
+	self->seek = NULL;
+	self->tell = NULL;
+	self->get_size = NULL;
+	self->get_modified_time = NULL;
+}
+
+GType
+logview_iface_io_get_type (void)
+{
+	static GType type = 0;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (LogviewIFaceIO),
+			logview_iface_base_init,   /* base_init */
+			NULL,   /* base_finalize */
+			logview_iface_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			0,
+			0,      /* n_preallocs */
+			NULL    /* instance_init */
+		};
+		type = g_type_register_static (G_TYPE_INTERFACE,
+					       g_intern_static_string ("LogviewIFaceIOType"),
+					       &info, 0);
+		g_type_interface_add_prerequisite (type, LOGVIEW_TYPE_IFACE);
+	}
+	return type;
+}
+
+/**
+ * logi_can_monitor:
+ * @self: a #LogviewIIO instance.
+ * 
+ * Check whether @self can be monitored.
+ * 
+ * Returns: Return TRUE, if it can.
+ **/
+gboolean
+logi_can_monitor (LogviewIIO *self)
+{
+	LogviewIFaceIO *iface = LOGVIEW_GET_IO_INTERFACE (self);
+	LV_MARK;
+	return iface->can_monitor(self);
+}
+
+/**
+ * logi_has_updated:
+ * @self: a #LogviewIIO instance.
+ * 
+ * Check if @self has changed since last reading happens.
+ *
+ * Returns: Return TRUE, if it can.
+ * */
+gboolean
+logi_has_updated (LogviewIIO *self)
+{
+	LV_MARK;
+	return LOGVIEW_GET_IO_INTERFACE (self)->has_updated(self);
+}
+
+/**
+ * logi_has_updated:
+ * @self: a #LogviewIIO instance.
+ * 
+ * Update @self to a new state, do not report True
+ * if call logi_has_updated() any more except a new change is made to @self.
+ */
+void
+logi_update (LogviewIIO *self)
+{
+	LV_MARK;
+	LOGVIEW_GET_IO_INTERFACE (self)->update(self);
+}
+
+/**
+ * logi_read:
+ * @self: a #LogviewIIO instance.
+ * @buffer: a buffer.
+ * @size: the length of the @buffer.
+ * 
+ * read, seek, tell are similiar to Standard C read, fseek, ftell.
+ * whence := SEEK_SET | SEEK_CUR | SEEK_END
+ * returns -1 if met error.
+ * but no errno currently.
+ * 
+ * Returns: Upon successful completion, logi_read() returns the size of
+ * successfully read. If @size is equal to 0, logi_read() returns 0 and
+ * the contents of the @buffer remain unchanged. Otherwise, if a read error
+ * occurs, returns -1.
+ */
+size_t
+logi_read (LogviewIIO *self, void* buffer, size_t size)
+{
+	LV_MARK;
+	return LOGVIEW_GET_IO_INTERFACE (self)->read(self, buffer, size);
+}
+
+/**
+ * logi_seek:
+ * @self: a #LogviewIIO instance.
+ * @offset: a offset.
+ * @whence: like fseek, accept SEEK_SET | SEEK_CUR | SEEK_END.
+ * 
+ * read, seek, tell are similiar to Standard C read, fseek, ftell.
+ * but no errno currently.
+ * 
+ * Returns: -1 if met error.
+ */
+off_t
+logi_seek (LogviewIIO *self, off_t offset, int whence)
+{
+	LV_MARK;
+	return LOGVIEW_GET_IO_INTERFACE (self)->seek(self, offset, whence);
+}
+
+/**
+ * logi_tell:
+ * @self: a #LogviewIIO instance.
+ * 
+ * read, seek, tell are similiar to Standard C read, fseek, ftell.
+ * but no errno currently.
+ * 
+ * Returns: On successful completion, returns the current offset
+ * opposite to the log head; returns -1 if met error.
+ */
+off_t
+logi_tell (LogviewIIO *self)
+{
+	LV_MARK;
+	return LOGVIEW_GET_IO_INTERFACE (self)->tell(self);
+}
+
+/**
+ * logi_get_size:
+ * @self: a #LogviewIIO instance.
+ * 
+ * Depends on logi_update(), report the size in one state of @self.
+ * 
+ * Returns: On successful completion, returns the current size of @self,
+ * else returns 0.
+ **/
+off_t
+logi_get_size (LogviewIIO* self)
+{
+	LV_MARK;
+	return LOGVIEW_GET_IO_INTERFACE (self)->get_size(self);
+}
+
+/**
+ * logi_get_modified_time:
+ * @self: a #LogviewIIO instance.
+ * 
+ * Depends on logi_update(), report the modified time in one state of @self.
+ * 
+ * Returns: On successful completion, returns the current size of @self,
+ * else returns 0.
+ **/
+time_t
+logi_get_modified_time (LogviewIIO* self)
+{
+	LV_MARK;
+	return LOGVIEW_GET_IO_INTERFACE (self)->get_modified_time(self);
+}
+
+/**
+ * logi_extract_filepath:
+ * @self: a #LogviewIIO instance.
+ * @dirname: returns a pointer points to the new alloc buffer
+ * contains the path name of @self.
+ * If passes NULL, the plugin should ignore this argument.
+ * @filename: returns a pointer points to the new alloc buffer
+ * contains the file name of @self.
+ * If passes NULL, the plugin should ignore this argument.
+ * 
+ * Extract the path name and the file name from $self, which will be displayed on
+ * Gnome System Log left tree pane.
+ **/
+void
+logi_extract_filepath (LogviewIIO *self, gchar** dirname, gchar** filename)
+{
+	LV_MARK;
+	LOGVIEW_GET_IO_INTERFACE (self)->extract_filepath(self, dirname, filename);
+}
diff --git a/logview/logview-iface-io.h b/logview/logview-iface-io.h
new file mode 100644
index 0000000..1ae5526
--- /dev/null
+++ b/logview/logview-iface-io.h
@@ -0,0 +1,61 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifndef __LOGVIEW_IFACE_IO_H__
+#define __LOGVIEW_IFACE_IO_H__
+
+#include <sys/types.h>
+#include <glib-object.h>
+#include <glib.h>
+
+G_BEGIN_DECLS
+
+#define LOGVIEW_TYPE_IFACE_IO \
+	(logview_iface_io_get_type ())
+#define LOGVIEW_IFACE_IO(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST ((obj), LOGVIEW_TYPE_IFACE_IO, \
+				     LogviewIIO))
+#define LOGVIEW_IS_IFACE_IO(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), LOGVIEW_TYPE_IFACE_IO))
+#define LOGVIEW_GET_IO_INTERFACE(obj) \
+	(G_TYPE_INSTANCE_GET_INTERFACE ((obj), LOGVIEW_TYPE_IFACE_IO, \
+					LogviewIFaceIO))
+
+typedef struct _LogviewIIO LogviewIIO; /* dummy object */
+typedef struct _LogviewIFaceIO LogviewIFaceIO;
+
+struct _LogviewIFaceIO {
+	GTypeInterface parent;
+
+	gboolean (*can_monitor) (LogviewIIO *self);
+	void (*extract_filepath) (LogviewIIO *self,
+				  gchar** dirname, gchar** filename);
+	gboolean (*has_updated) (LogviewIIO *self);
+	void (*update) (LogviewIIO *self);
+	size_t (*read) (LogviewIIO *self, void* buffer, size_t size);
+	off_t (*seek) (LogviewIIO *self, off_t offset, int whence);
+	off_t (*tell) (LogviewIIO *self);
+	off_t (*get_size) (LogviewIIO* self);
+	time_t (*get_modified_time) (LogviewIIO* self);
+
+};
+
+extern GType logview_iface_io_get_type (void) G_GNUC_CONST;
+
+/* for logview application internal usage */
+extern gboolean logi_can_monitor (LogviewIIO *self);
+extern void logi_extract_filepath (LogviewIIO *self,
+			    gchar** dirname, gchar** filename);
+extern gboolean logi_has_updated (LogviewIIO *self);
+extern void logi_update (LogviewIIO *self);
+extern size_t logi_read (LogviewIIO *self, void* buffer, size_t size);
+extern off_t logi_seek (LogviewIIO *self, off_t offset, int whence);
+extern off_t logi_tell (LogviewIIO *self);
+extern off_t logi_get_size (LogviewIIO* self);
+extern time_t logi_get_modified_time (LogviewIIO* self);
+
+G_END_DECLS
+
+#endif /* __LOGVIEW_IFACE_H__ */
diff --git a/logview/logview-iface-view.c b/logview/logview-iface-view.c
new file mode 100644
index 0000000..5e3b55c
--- /dev/null
+++ b/logview/logview-iface-view.c
@@ -0,0 +1,87 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#include "logview-iface.h"
+#include "logview-iface-view.h"
+#include "logview-debug.h"
+
+static void
+logview_iface_base_init (gpointer gclass)
+{
+	static gboolean initialized = FALSE;
+	if (!initialized) {
+		initialized = TRUE;
+	}
+}
+
+static void
+logview_iface_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LogviewIFaceView *self = (LogviewIFaceView *)g_class;
+	self->group_lines = NULL;
+	self->to_utf8 = NULL;
+}
+
+GType
+logview_iface_view_get_type (void)
+{
+	static GType type = 0;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (LogviewIFaceView),
+			logview_iface_base_init,   /* base_init */
+			NULL,   /* base_finalize */
+			logview_iface_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			0,
+			0,      /* n_preallocs */
+			NULL    /* instance_init */
+		};
+		type = g_type_register_static (G_TYPE_INTERFACE,
+					       g_intern_static_string ("LogviewIFaceViewType"),
+					       &info, 0);
+		g_type_interface_add_prerequisite (type, LOGVIEW_TYPE_IFACE);
+	}
+	return type;
+}
+
+/**
+ * logi_group_lines:
+ * @self: a #LogviewIView instance.
+ * @lines: an array of strings, terminates in NULL.
+ * 
+ * Passes an array of strings to logi_group_lines(),
+ * the plugin should try to group these strings by date.
+ * 
+ * Returns: a single list with each element is a #Day object.
+ **/
+GSList*
+logi_group_lines (LogviewIView *self, const gchar **lines)
+{
+	LV_MARK;
+	return LOGVIEW_GET_VIEW_INTERFACE (self)->group_lines(self, lines);
+}
+
+/**
+ * logi_to_utf8:
+ * @self: a #LogviewIView instance.
+ * @str: a string.
+ * @size: the length of @str.
+ * 
+ * Gnome System Log will call this routine before displays the string on the screen.
+ * 
+ * Returns: a converted string, which will be freed by Gnome System Log.
+ **/
+gchar*
+logi_to_utf8 (LogviewIView *self, gchar *str, gssize size)
+{
+	LogviewIFaceView *iface = LOGVIEW_GET_VIEW_INTERFACE (self);
+	LV_MARK;
+	if (iface->to_utf8)
+		return iface->to_utf8 (self, str, size);
+	return str;
+}
diff --git a/logview/logview-iface-view.h b/logview/logview-iface-view.h
new file mode 100644
index 0000000..b32330b
--- /dev/null
+++ b/logview/logview-iface-view.h
@@ -0,0 +1,54 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifndef __LOGVIEW_IFACE_VIEW_H__
+#define __LOGVIEW_IFACE_VIEW_H__
+
+#include <glib-object.h>
+#include "logview-log.h"
+
+G_BEGIN_DECLS
+
+#define LOGVIEW_TYPE_IFACE_VIEW \
+	(logview_iface_view_get_type ())
+#define LOGVIEW_IFACE_VIEW(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST((obj), LOGVIEW_TYPE_IFACE_VIEW, \
+				     LogviewIView))
+#define LOGVIEW_IS_IFACE_VIEW(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE((obj), LOGVIEW_TYPE_IFACE_VIEW))
+#define LOGVIEW_GET_VIEW_INTERFACE(obj) \
+	(G_TYPE_INSTANCE_GET_INTERFACE((obj), LOGVIEW_TYPE_IFACE_VIEW, \
+					LogviewIFaceView))
+
+typedef struct _LogviewIView LogviewIView;
+typedef struct _LogviewIFaceView LogviewIFaceView;
+
+struct _LogviewIFaceView {
+	GTypeInterface parent;
+
+	/* 
+	   Create a list, each element is a group entry,
+	   each group entry has a log list, do not free mass.
+	   returns NULL if failed.
+	*/
+	GSList* (*group_lines) (LogviewIView *self, const gchar **lines);
+
+	/* 
+	   If possible, convert a string to utf8, free the original
+	   string, return the new one.
+	*/
+	gchar* (*to_utf8) (LogviewIView *self, gchar *str, gssize size);
+};
+
+extern GType logview_iface_view_get_type (void) G_GNUC_CONST;
+
+/* for logview application internal usage */
+extern GSList* logi_group_lines (LogviewIView *self, const gchar **lines);
+extern gchar* logi_to_utf8 (LogviewIView *self, gchar *str, gssize size);
+
+G_END_DECLS
+
+#endif /* __LOGVIEW_IFACE_VIEW_H__ */
+
diff --git a/logview/logview-iface.c b/logview/logview-iface.c
new file mode 100644
index 0000000..865073a
--- /dev/null
+++ b/logview/logview-iface.c
@@ -0,0 +1,69 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+ 
+#include "logview-iface.h"
+#include "logview-debug.h"
+
+static void
+logview_iface_base_init (gpointer gclass)
+{
+	static gboolean initialized = FALSE;
+	if (!initialized) {
+		initialized = TRUE;
+	}
+}
+
+static void
+logview_iface_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LogviewInterface *self = (LogviewInterface *)g_class;
+	self->can_handle = NULL;
+}
+
+GType
+logview_iface_get_type (void)
+{
+	static GType type = 0;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (LogviewInterface),
+			logview_iface_base_init,   /* base_init */
+			NULL,   /* base_finalize */
+			logview_iface_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			0,
+			0,      /* n_preallocs */
+			NULL    /* instance_init */
+		};
+		type = g_type_register_static (G_TYPE_INTERFACE,
+					       g_intern_static_string ("LogviewInterfaceType"),
+					       &info, 0);
+	}
+	return type;
+}
+
+/**
+ * logi_can_handle:
+ * @self: a #LogviewIFace instance.
+ * @log: a #Log instance.
+ * 
+ * Check whether the @log can be handled.
+ * 
+ * Returns: If this interface is not overwritten,
+ * it default returns TRUE means the @log can be recognized.
+ **/
+gboolean
+logi_can_handle (LogviewIFace *self, struct _Log* log)
+{
+	LogviewInterface *iface = LOGVIEW_GET_INTERFACE (self);
+	//LV_MARK;
+	if (iface->can_handle)
+		return (iface)->can_handle(self, log);
+	return TRUE;
+}
+
diff --git a/logview/logview-iface.h b/logview/logview-iface.h
new file mode 100644
index 0000000..cb8b2b8
--- /dev/null
+++ b/logview/logview-iface.h
@@ -0,0 +1,43 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifndef __LOGVIEW_IFACE_H__
+#define __LOGVIEW_IFACE_H__
+
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define LOGVIEW_TYPE_IFACE \
+	(logview_iface_get_type ())
+#define LOGVIEW_IFACE(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST((obj), LOGVIEW_TYPE_IFACE, \
+				     LogviewIFace))
+#define LOGVIEW_IS_IFACE(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE((obj), LOGVIEW_TYPE_IFACE))
+#define LOGVIEW_GET_INTERFACE(obj) \
+	(G_TYPE_INSTANCE_GET_INTERFACE((obj), LOGVIEW_TYPE_IFACE, \
+					LogviewInterface))
+
+struct _Log;
+
+typedef struct _LogviewIFace LogviewIFace; /* dummy object */
+typedef struct _LogviewInterface LogviewInterface;
+
+struct _LogviewInterface {
+	GTypeInterface parent;
+
+	gboolean (*can_handle) (LogviewIFace *self, struct _Log* log);
+};
+
+GType logview_iface_get_type (void);
+
+/* for logview application internal usage */
+gboolean logi_can_handle (LogviewIFace *self, struct _Log* log);
+
+G_END_DECLS
+
+#endif /* __LOGVIEW_IFACE_H__ */
+
